/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games.minorstates;

import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Game;
import javachan.games.Keymap;
import javachan.games.MainGame;

public class YesNoMinorState implements MinorState {
    public boolean yesNoState;
    public int yesDest;
    public YesNoMinorState(int yesDest)
    {
        this.yesDest=yesDest;
        yesNoState=false;
    }
    @Override
    public void doUpdate(MainGame mainGame, Game g, double DeltaTime, boolean tickNow) {
        if (g.graphics.isKeyJustPressed(Keymap.VK_LEFT)) {
            yesNoState = true;
        }
        if (g.graphics.isKeyJustPressed(Keymap.VK_RIGHT)) {
            yesNoState = false;
        }
        if (g.graphics.isKeyJustPressed(Keymap.VK_SWIM)) {
            mainGame.minorState = null;
            if (yesNoState)
                mainGame.scriptPoint = yesDest;
        }
        drawYN(g.graphics, yesNoState);
    }

    private void drawYN(IGrInDriver graphics, boolean b) {
        IImage yesno = graphics.getImage("Pbm/YesNo.pbm", 0, 0, 0);
        // offset for yesno signs from backings
        int ox = 9;
        int oy = 7;
        // offset for yesno backings from top left of screen
        int xx = 0;
        int yy = 0;
        xx = ((graphics.getWidth() / 2) - 16) - (yesno.getWidth() - 48);
        yy = (graphics.getHeight() / 2) - yesno.getHeight();
        if (b) {
            graphics.blitBCKImage(48, 0, yesno.getWidth() - 48,
                    yesno.getHeight(), xx, yy, yesno);
        }
        graphics.blitBCKImage(0, 0, 48, yesno.getHeight() / 2, xx + ox,
                yy + oy, yesno);
        xx = ((graphics.getWidth() / 2) + 16);
        if (!b) {
            graphics.blitBCKImage(48, 0, yesno.getWidth() - 48,
                    yesno.getHeight(), xx, yy, yesno);
        }
        graphics.blitBCKImage(0, yesno.getHeight() / 2, 48,
                yesno.getHeight() / 2, xx + ox, yy + oy, yesno);
    }
}
