/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class SleepNPCType extends BasicNPCType {
    public SleepNPCType()
    {
        drawSizeX = 20;
        drawSizeY = 20;
        drawOfsX = -2;
        drawOfsY = -4;
    }
    
    @Override
    public Rect GetRectangle(GameStateNPChar.NPCCharacter In)
    {
        return new Rect((int)(In.posX*16)+3,(int)(In.posY*16)+6,10,10);
    }    

    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        boolean in=new Rect((int)(npc.posX*16)-16,(int)(npc.posY*16)-16,48,48).contains((int)(gs.getX()*16), (int)(gs.getY()*16));
        if (in)
        {
            if (npc.entityStatus<11)
                npc.entityStatus++;
        } else {
            if (npc.entityStatus>0)
                npc.entityStatus--;
        }
        int f=npc.entityStatus/3;
        npc.displayX=(f&1);
        npc.displayY=(f&2)/2;
    }
}
